=== interpolation/CMakeLists.txt ===
list( APPEND interpolation_src_files

  current.h
  grdynam.h
  grfixed.h
  grspace.h
  intf.h
  intlog.h
  jparams.h
  memreq.h
  parim.h

  areachk.F
  auresol.F
  chequal.F
  chkout.F
  chkprec.F
  clear_c.F
  ddstyle.F
  dpath_tables_interpol.F90
  dssarea.F
  estima.F
  fft99.F
  fixarea.F
  forced_fftw.F
  forced_nearest_neighbour.F
  freecf.F
  funcs.F
  gasetup.F
  getconf.F
  gettru.F
  gghtype.F
  ggintrp.F
  gglonlat.F
  ggrotat.F
  ggvalue.F
  global.F
  hgengg.F
  hgengrd.F
  hgengrw.F
  hgenll.F
  hgetlsm.F
  hirlam.F
  hirlamw.F
  hirlsm.F
  hll2ll.F
  hll2llw.F
  hll2xyz.F
  hnei12.F
  hneill.F
  hntfap.F
  hntfaph.F
  hntfaps.F
  hntfau.F
  hntfauh.F
  hntfaus.F
  hpshgpw.F
  hrg2gg.F
  hrg2ggw.F
  hsh2gg.F
  hsp2gg.F
  hsp2gg2.F
  hsp2gg3.F
  hwts12.F
  hwtsll.F
  hwtslsm.F
  iafree.F
  iagcntl.F
  iainit.F
  iarcntl.F
  ibasini.F
  igalloc.F
  igbess.F
  igdins.F
  igdiwe.F
  igglat.F
  iggmem.F
  iggrid.F
  igint.F
  igintr.F
  iglgrid.F
  iglsize.F
  iglsm01.F
  iglsmb.F
  iglsmd.F
  iglsmr.F
  iglsmst.F
  ignorm.F
  igplsm.F
  igpoleg.F
  igpolew.F
  igprec.F
  igsetup.F
  igsize.F
  igtog.F
  insane.F
  intf.F
  intfap.F
  intfau.F
  intfb.F
  intfbu.F
  intin.F
  intisl.F
  intlog.F
  intlogd.F
  intlogr.F
  intocn.F
  intocnu.F
  intout.F
  intpnum.F
  intuvdh.F
  intuvgh.F
  intuvp.F
  intuvs.F
  intuvu.F
  intuvxh.F
  intuvy.F
  intvecy.F
  intwave2.F
  intwavu.F
  irdiwe.F
  irgmem.F
  irgrid.F
  irgtog.F
  irint.F
  irintr.F
  irlsmb.F
  irprec.F
  irsize.F
  is_wave_direction.F
  iscrsz.F
  isggvalid.F
  islproc.F
  isoctahedral.F
  issame.F
  issameiarray.F
  issamerarray.F
  jacobi.F
  jagggp.F
  jallgp.F
  jallwn.F
  jbess.F
  jdebug.F
  jfindfn.F
  jfindfn3.F
  jfindir.F
  jgetgg.F
  jgglat.F
  jjset99.F
  jmakgg.F
  jmakgg3.F
  jmakll.F
  jmakll3.F
  jmemhan.F
  jmemhan2.F
  jmkofgg.F
  jmovgg.F
  jmovll.F
  jmvugg.F
  jmvull.F
  jnorsgg.F
  jnumgg.F
  jopngg.F
  jopnggf.F
  jopnll.F
  jopnllf.F
  jreadgg.F
  jreadll.F
  jsgggp.F
  jsh2sh.F
  jsllgp.F
  jspleg1.F
  jsppole.F
  jstrll.F
  jstrwll.F
  jsymgg.F
  jsymll.F
  juvpole.F
  jvod2uv.F
  jwindll.F
  jwscal.F
  kintrg.F
  knfrom4.F
  krg2rg.F
  krg2rgd.F
  krg2rgu.F
  krg2rgy.F
  krg2rgz.F
  ll2xyz.F
  lsm_red.F
  lsmfld.F
  mkbitmp.F
  mkframe.F
  newisl.F
  ngintrp.F
  ngrotat.F
  ngvalue.F
  nmakgg.F
  nmakll.F
  numptns.F
  numptwe.F
  oceanp.F
  oceanu.F
  outrep.F
  pddefs.F
  precip.F
  qgoct.F
  qpassm.F
  reset_c.F
  rpassm.F
  rphi.F
  set99.F
  setrep.F
  sscal.F
  strlat.F
  w251idx.F
  waveidx.F
  wavexx2.F
  wv2didx.F
  wv2dint.F
  wv2dxx2.F
  wvqlidx.F
  wvqlint.F
  xyz2ll.F
  yrotate.F
  zprec.F

  emosPrecision.c
  fftchk.c
  gmapbit.c
  intlogs.c
  jchmod.c
  jindex.c
  jopnggsm.c
  jopnllsm.c
  makemap.c
  rename_unlink.c
  shareddt.c
  sharedgg.c
  sharedlib.c
  sharedll.c

  # (former grib_api_merging/)
  copy_spec_from_ksec.c
  describe_input_field.c
  emos.c
  emos.h
  intf2.c
  intuvp2.c
  intuvs2.c
  intvect2.c
)


foreach( src ${interpolation_src_files} )
  list( APPEND interpolation_srcs interpolation/${src} )
endforeach()

set( interpolation_srcs ${interpolation_srcs} PARENT_SCOPE )
