=== tools/lsmReducedGaussian/CMakeLists.txt ===

# configure Fortran-based targets for double precision (compilation & linking)
ecbuild_add_fortran_flags(${emos_double_precision_flags})

ecbuild_add_executable(
  TARGET  ginout_c2 NOINSTALL
  SOURCES ginout_c2.f90
  LIBS    emos )
