=== debian/changelog ===
emoslib (2:4.3.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS on sparc64. Closes: #813649.
    - Set mcmodel=medany in debian/rules.
    - Add sparc64 to FPIC_LIST in debian/rules.
  * Remove trailing spaces in debian/changelog.
  * Wrap lines longer than 80 columns in debian/changelog.

 -- John Paul Adrian Glaubitz <glaubitz@physik.fu-berlin.de>  Mon, 08 Feb 2016 09:46:14 +0100

emoslib (2:4.3.7-1) unstable; urgency=medium

  * New upstream release.
  * Use -fPIC on m68k. Closes: #810389.
  * Standards-Version: 3.9.7. No changes required.
  * FFTW3 now required by EMOSLIB.
  * Set mcmodel=large for sparc64. Closes: #813649.
  * Ack, previously fixed symlink bug: Closes: #799854.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 04 Feb 2016 13:04:39 +0000

emoslib (2:4.3.3-2) unstable; urgency=medium

  * Change libpng12-dev to libpng-dev for png16 transition. Closes: #810168.

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 07 Jan 2016 17:11:03 +0000

emoslib (2:4.3.3-1) unstable; urgency=medium

  * New upstream release.
    Provides new octahedral Gauss. grid support.
  * Refreshed patches. huge.patch, wvqlid2.patch no longer needed.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 04 Jan 2016 03:39:28 +0000

emoslib (2:4.1.1-6) unstable; urgency=medium

  * Use -fPIC building on s390x to resolve GOT linking errors.
  * Link "--as-needed".

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 06 Nov 2015 19:12:20 +0000

emoslib (2:4.1.1-5) unstable; urgency=medium

  * Add s390x to the list of archs on which we disable tests.
  * Set INTERPOL_TABLES_PATH during build to be install location.
  * Set libemos-bin as MultiArch: allowed, with libemos-dev depend on
    libemos-bin:any
  * Fix interpol links in libemos-data to be relative.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Oct 2015 13:17:32 +0000

emoslib (2:4.1.1-4) unstable; urgency=medium

  * Disable tests for big-endian systems (being worked on upstream).

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 28 Oct 2015 03:05:01 +0000

emoslib (2:4.1.1-3) experimental; urgency=medium

  * Disable download of bufr tests.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 27 Oct 2015 16:06:30 +0000

emoslib (2:4.1.1-2) experimental; urgency=medium

  * Change /usr/lib/*/cmake/Emos -> /usr/lib/*/cmake/libemos
  * libemos-dev now depends on libemos-bin as cmake configs
    assume binaries are available.
  * Now need libboost-test-dev optional package.
  * Re-enable tests.
  * Fixup libemos-dev cmake files for metview to compile.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 24 Oct 2015 20:58:07 +0100

emoslib (2:4.1.1-1) unstable; urgency=medium

  * New upstream release.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 21 Oct 2015 12:38:35 +0100
